Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/CreateRuleDialog.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/CreateRuleDialog.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/CreateRuleDialog.java	(revision 727)
@@ -5,16 +5,29 @@
  */
 package org.gvsig.topology.swing.impl;
 
+import java.awt.Component;
 import java.awt.Dimension;
 import java.awt.event.ItemEvent;
 import java.awt.event.ItemListener;
+import java.util.Objects;
 import javax.swing.DefaultComboBoxModel;
+import javax.swing.DefaultListCellRenderer;
+import javax.swing.ImageIcon;
+import javax.swing.JLabel;
+import javax.swing.JList;
+import javax.swing.ListCellRenderer;
 import javax.swing.event.DocumentEvent;
 import javax.swing.event.DocumentListener;
+import org.gvsig.fmap.dal.DataStore;
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryUtils;
 import org.gvsig.tools.swing.api.ToolsSwingLocator;
 import org.gvsig.tools.swing.api.ToolsSwingManager;
 import org.gvsig.tools.swing.api.windowmanager.Dialog;
 import org.gvsig.tools.swing.api.windowmanager.WindowManager_v2;
+import org.gvsig.tools.swing.icontheme.IconTheme;
 import org.gvsig.topology.lib.api.TopologyDataSet;
 import org.gvsig.topology.lib.api.TopologyLocator;
 import org.gvsig.topology.lib.api.TopologyManager;
@@ -29,6 +42,50 @@
 @SuppressWarnings("UseSpecificCatch")
 public class CreateRuleDialog extends CreateRuleDialogView {
 
+    private class DataSetListCellRenderer extends DefaultListCellRenderer {
+
+        private ImageIcon pointIcon;
+        private ImageIcon lineIcon;
+        private ImageIcon polygonIcon;
+
+        public DataSetListCellRenderer() {
+            IconTheme iconTheme = ToolsSwingLocator.getIconThemeManager().getCurrent();
+            if( iconTheme.exists("layer-type-point") ) {
+                this.pointIcon = iconTheme.get("layer-type-point");
+            }
+            if( iconTheme.exists("layer-type-line") ) {
+                this.lineIcon = iconTheme.get("layer-type-line");
+            }
+            if( iconTheme.exists("layer-type-polygon") ) {
+                this.polygonIcon = iconTheme.get("layer-type-polygon");
+            }
+        }
+        
+        @Override
+        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
+            JLabel label = (JLabel) super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
+            this.setText(Objects.toString(value, ""));
+            this.setIcon(null);
+            if( value instanceof TopologyDataSet ) {
+                DataStore store = ((TopologyDataSet) value).getStore();
+                if( store instanceof FeatureStore ) {
+                    try {
+                        int geomtype = ((FeatureStore) store).getDefaultFeatureType().getDefaultGeometryAttribute().getGeomType().getType();
+                        if( GeometryUtils.isSubtype(Geometry.TYPES.POINT, geomtype) ) {
+                            this.setIcon(this.pointIcon);
+                        } else if( GeometryUtils.isSubtype(Geometry.TYPES.SURFACE, geomtype) ) {
+                            this.setIcon(this.polygonIcon);
+                        } else if( GeometryUtils.isSubtype(Geometry.TYPES.CURVE, geomtype) ) {
+                            this.setIcon(this.lineIcon);
+                        }
+                    } catch (DataException ex) {
+                    }
+                }
+            }
+            return label;
+        }
+        
+    }
     private final TopologyPlan plan;
     private Dialog dialog;
 
@@ -56,6 +113,8 @@
                 performDataSet1Selected();
             }
         });
+//        this.cboDataSet1.setRenderer(new DataSetListCellRenderer());
+//        this.cboDataSet2.setRenderer(new DataSetListCellRenderer());
         this.cboRule.addItemListener(new ItemListener() {
             @Override
             public void itemStateChanged(ItemEvent e) {
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/TopologySwingImplLibrary.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/TopologySwingImplLibrary.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/TopologySwingImplLibrary.java	(revision 727)
@@ -23,9 +23,12 @@
  */
 package org.gvsig.topology.swing.impl;
 
+import java.net.URL;
 import org.gvsig.tools.ToolsLibrary;
 import org.gvsig.tools.library.AbstractLibrary;
 import org.gvsig.tools.library.LibraryException;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.icontheme.IconTheme;
 import org.gvsig.topology.lib.api.TopologyLibrary;
 import org.gvsig.topology.lib.api.TopologyLocator;
 import org.gvsig.topology.lib.api.TopologyManager;
@@ -50,10 +53,21 @@
     @Override
     protected void doInitialize() throws LibraryException {
         TopologySwingLocator.registerDefaultTopologySwingManager(DefaultTopologySwingManager.class);
+        
     }
 
     @Override
     protected void doPostInitialize() throws LibraryException {
+        String[][] iconNames = new String[][] {
+            new String[] { "layertypes", "layer-type-point" },
+            new String[] { "layertypes", "layer-type-line" },
+            new String[] { "layertypes", "layer-type-polygon" }
+        };
+        IconTheme theme = ToolsSwingLocator.getIconThemeManager().getCurrent();
+        for (String[] icon : iconNames) {
+            URL url = this.getClass().getResource("images/layertypes"+icon[1]+".png");
+            theme.registerDefault("topology", icon[0], icon[1], null, url);
+        }
     }
 
 }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.api/src/main/java/org/gvsig/topology/swing/api/TopologySwingServices.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.api/src/main/java/org/gvsig/topology/swing/api/TopologySwingServices.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.api/src/main/java/org/gvsig/topology/swing/api/TopologySwingServices.java	(revision 727)
@@ -23,7 +23,10 @@
  */
 package org.gvsig.topology.swing.api;
 
+import javax.swing.ImageIcon;
 import javax.swing.tree.TreeModel;
+import javax.swing.tree.TreePath;
+import org.gvsig.fmap.geom.Geometry;
 import org.gvsig.fmap.geom.primitive.Envelope;
 import org.gvsig.fmap.geom.primitive.Point;
 import org.gvsig.topology.lib.api.TopologyServices;
@@ -52,4 +55,10 @@
     public void removeWorkingAreaChangedListener(WorkingAreaChangedListener listener);
 
     public void refreshView();
+    
+    public void addError(Geometry geom);
+    
+    public void setShowFormWhenEdit(boolean showFormWhenEdit);
+    
+    public ImageIcon getTreeIcon(TreeModel model, Object item);
 }
